var com_xk72_charles = function() {
	
	/* Find charles signal file */
	var signalFile = firefoxProfileDir();
	signalFile.append("charles_port");
	var signalFileLastModified = 0;
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService);
	
	function isEnabled() {
		try {
			return prefs.getBranch("").getBoolPref("extensions.charles.enabled");
		} catch (e) {
			return false;
		}
	}
	
	function isDirectConnection() {
		var ray = downloadLiveSettings();
		return ray["network.proxy.type"] == 0;
	}
	
	function setEnabled(enabled) {
		prefs.getBranch("").setBoolPref("extensions.charles.enabled", enabled);
	}
	
	function downloadSettings(branch) {
		var prefsBranch = prefs.getBranch(branch);
		
		var ray = {};
		ray["network.proxy.http"] = safe_getCharPref(prefsBranch, "network.proxy.http");
		ray["network.proxy.ssl"] = safe_getCharPref(prefsBranch, "network.proxy.ssl");
		ray["network.proxy.socks"] = safe_getCharPref(prefsBranch, "network.proxy.socks");
		ray["network.proxy.no_proxies_on"] = safe_getCharPref(prefsBranch, "network.proxy.no_proxies_on");
		ray["network.proxy.http_port"] = safe_getIntPref(prefsBranch, "network.proxy.http_port");
		ray["network.proxy.ssl_port"] = safe_getIntPref(prefsBranch, "network.proxy.ssl_port");
		ray["network.proxy.socks_port"] = safe_getIntPref(prefsBranch, "network.proxy.socks_port");
		ray["network.proxy.type"] = safe_getIntPref(prefsBranch, "network.proxy.type");
		ray["network.proxy.share_proxy_settings"] = safe_getBoolPref(prefsBranch, "network.proxy.share_proxy_settings");
		
		/*var msgs = "downloaded: " + branch;
		for (var i in ray) {
			msgs += " " + i + "=" + ray[i];
		}
		alert(msgs);*/
		return ray;
	}
	
	function safe_getCharPref(prefs, name) {
		try {
			return prefs.getCharPref(name);
		} catch (e) {
			return "";
		}
	}
	
	function safe_getIntPref(prefs, name) {
		try {
			return prefs.getIntPref(name);
		} catch (e) {
			return 0;
		}
	}
	
	function safe_getBoolPref(prefs, name) {
		try {
			return prefs.getBoolPref(name);
		} catch (e) {
			return false;
		}
	}
	
	function uploadSettings(branch, ray) {
		var prefsBranch = prefs.getBranch(branch);
		
		prefsBranch.setCharPref("network.proxy.http", ray["network.proxy.http"]);
		prefsBranch.setCharPref("network.proxy.ssl", ray["network.proxy.ssl"]);
		prefsBranch.setCharPref("network.proxy.socks", ray["network.proxy.socks"]);
		prefsBranch.setCharPref("network.proxy.no_proxies_on", ray["network.proxy.no_proxies_on"]);
		prefsBranch.setIntPref("network.proxy.http_port", ray["network.proxy.http_port"]);
		prefsBranch.setIntPref("network.proxy.ssl_port", ray["network.proxy.ssl_port"]);
		prefsBranch.setIntPref("network.proxy.socks_port", ray["network.proxy.socks_port"]);
		prefsBranch.setIntPref("network.proxy.type", ray["network.proxy.type"]);
		prefsBranch.setBoolPref("network.proxy.share_proxy_settings", ray["network.proxy.share_proxy_settings"]);
	}
	
	function downloadLiveSettings() {
		return downloadSettings("");
	}
	
	function downloadEnabledSettings() {
		return downloadSettings("extensions.charles.settings.enabled.");
	}
	
	function downloadDisabledSettings() {
		return downloadSettings("extensions.charles.settings.disabled.");
	}
	
	function uploadLiveSettings(ray) {
		uploadSettings("", ray);
	}
	
	function uploadEnabledSettings(ray) {
		uploadSettings("extensions.charles.settings.enabled.", ray);
	}
	
	function uploadDisabledSettings(ray) {
		uploadSettings("extensions.charles.settings.disabled.", ray);
	}
	
	function compareSettings(a, b) {
		/* Only check a few of the settings, as we might not get an exact match (for instance as we change what
		 * we upload when the extension version changes?) So we check for the main ones that indicate we're the
		 * same
		 */
	
		return (a["network.proxy.http"] == b["network.proxy.http"]
			&& a["network.proxy.http_port"] == b["network.proxy.http_port"]
			&& a["network.proxy.socks"] == b["network.proxy.socks"]
			&& a["network.proxy.socks_port"] == b["network.proxy.socks_port"]
			&& a["network.proxy.type"] == b["network.proxy.type"]);
	}
	
	function checkConfig() {
		if (isEnabled()) {
			var live_settings = downloadLiveSettings();
			var enabled_settings = downloadEnabledSettings();
			
			if (!compareSettings(live_settings, enabled_settings)) {
				/* No longer enabled */
				setEnabled(false);
				
//				var a = live_settings;
//				var b = enabled_settings;
//				alert(a["network.proxy.http"] + " vs " + b["network.proxy.http"]);
//				alert(a["network.proxy.http_port"] + " vs " + b["network.proxy.http_port"]);
//				alert(a["network.proxy.socks"] + " vs " + b["network.proxy.socks"]);
//				alert(a["network.proxy.socks_port"] + " vs " + b["network.proxy.socks_port"]);
//				alert(a["network.proxy.type"] + " vs " + b["network.proxy.type"]);
				signalFile.remove(false);
			}
		}
	}
	
	function enable(port, socksPort, bypassDomains) {
		var live_settings = downloadLiveSettings();
		var enabled_settings = {
			"network.proxy.no_proxies_on": bypassDomains,
			"network.proxy.type": 1,
			"network.proxy.share_proxy_settings": false
		};
		if (port > 0) {
			enabled_settings["network.proxy.http"] = "127.0.0.1";
			enabled_settings["network.proxy.ssl"] = "127.0.0.1";
			enabled_settings["network.proxy.http_port"] = port;
			enabled_settings["network.proxy.ssl_port"] = port;
		} else {
			enabled_settings["network.proxy.http"] = "";
			enabled_settings["network.proxy.ssl"] = "";
			enabled_settings["network.proxy.http_port"] = 0;
			enabled_settings["network.proxy.ssl_port"] = 0;
		}
		if (socksPort > 0) {
			enabled_settings["network.proxy.socks"] = "127.0.0.1";
			enabled_settings["network.proxy.socks_port"] = socksPort;
		} else {
			enabled_settings["network.proxy.socks"] = "";
			enabled_settings["network.proxy.socks_port"] = 0;
		}
		
		if (!isEnabled()) {
			/* Store current values */
			if (!compareSettings(enabled_settings, live_settings)) {
				uploadDisabledSettings(live_settings);
			}
		}
		
		/* Set new values */
		uploadEnabledSettings(enabled_settings);
		uploadLiveSettings(enabled_settings);
		
		setEnabled(true);
	}
	
	function disable() {
		if (isEnabled()) {
			setEnabled(false);
			
			var disabled_settings = downloadDisabledSettings();
			var live_settings = downloadLiveSettings();
			if (compareSettings(live_settings, disabled_settings)) {
				disabled_settings = {
				"network.proxy.http": "",
				"network.proxy.ssl": "",
				"network.proxy.socks": "",
				"network.proxy.http_port": 0,
				"network.proxy.ssl_port": 0,
				"network.proxy.socks_port": 0,
				"network.proxy.no_proxies_on": "",
				"network.proxy.type": 0,
				"network.proxy.share_proxy_settings": false
				};
			}
			uploadLiveSettings(disabled_settings);
		}
	}
	
	function activateDirectConnection() {
		disable();
		var live_settings = downloadLiveSettings();
		live_settings["network.proxy.type"] = 0;
		uploadLiveSettings(live_settings);
	}
	
	function checkFile(aSignalFile) {
		// open an input stream from file
		var istream = Components.classes["@mozilla.org/network/file-input-stream;1"]
		                        .createInstance(Components.interfaces.nsIFileInputStream);
		istream.init(aSignalFile, 0x01, 0444, 0);
		istream.QueryInterface(Components.interfaces.nsILineInputStream);
		
		// read lines into array
		var line = {}, lines = [], hasmore;
		do {
		  hasmore = istream.readLine(line);
		  lines.push(line.value); 
		} while(hasmore);
		
		istream.close();
		
		var ports = lines[0].split(/ /);
		
		var port = ports[0];
		var socksPort = ports.length > 1 ? ports[1] : -1;
		var bypassDomains;
		if (lines.length > 1) {
			bypassDomains = lines[1];
		}
		else {
			bypassDomains = "";
		}
		
		if (port > 0 || socksPort > 0)  {
			enable(port, socksPort, bypassDomains);
		}
		else {
			disable();
		}
	}
	
	function check() {
		if (signalFile.exists()) {
			var t = signalFile.lastModifiedTime;
			if (t > signalFileLastModified) {
				checkFile(signalFile);
				signalFileLastModified = t;
			}
		} else {
			if (signalFileLastModified != -1) {
				disable();
				signalFileLastModified = -1;
			}
		}
		
		checkConfig();
	}
	
	function setMenuChecked(id, checked) {
		document.getElementById(id).setAttribute("checked", checked);
	}
	
	function showingMenu(menu) {
		var directConnection = isDirectConnection();
		var charlesEnabled = isEnabled();
		if (directConnection) {
			document.getElementById('com_xk72_charles_menu_status_direct').setAttribute("checked", true);
		} else if (charlesEnabled) {
			document.getElementById('com_xk72_charles_menu_status_charles').setAttribute("checked", true);
		} else {
			document.getElementById('com_xk72_charles_menu_status_other').setAttribute("checked", true);
		}
		
		if (!charlesEnabled) {
			document.getElementById('com_xk72_charles_menu_disable_charles').setAttribute("label", "Enable Charles Proxy");
		} else {
			document.getElementById('com_xk72_charles_menu_disable_charles').setAttribute("label", "Disable Charles Proxy");
		}
	}
	
	function menuDisableCharles() {
		var charlesEnabled = isEnabled();
		if (charlesEnabled) {
			disable();
		} else {
			if (signalFile.exists()) {
				signalFileLastModified = -1;
			} else {
				alert("Cannot find a running Charles. Please check that Charles is running and that " +
					"Mozilla Firefox Proxy is enabled in the Proxy menu in Charles.");
			}
		}
	}
	
	function menuDirectConnection() {
		activateDirectConnection();
		signalFile.remove(false);
	}
	
	function firefoxProfileDir() {
		return Components.classes["@mozilla.org/file/directory_service;1"]
	                     .getService(Components.interfaces.nsIProperties)
	                     .get("ProfD", Components.interfaces.nsIFile);
	}
	
	function menuDisplayFirefoxProfilePath() {
		window.prompt("The current Firefox profile path is displayed below. You can copy and paste this into the Proxy Settings in Charles if Charles is unable to automatically discover the profile path.", firefoxProfileDir().path);
	}
	
	function installCASSLCertificate() {
		alert("The Charles Firefox add-on will now attempt to install the Root certificate for your installation of Charles.\n\n" +
				"Note that you must have Charles v3.10 or later, and Firefox must be already using Charles as its proxy. " +
				"If you see a Server Not Found error, please check the above and try again.");
		
		location = 'http://ssl.charles/';
	}
	
	return {
		init: function() {
			try {
				check();
			} catch (e) {
				alert("Charles Autoconfiguration Add-on failed to initialise. Please report this: " + e);
			}
			setInterval(com_xk72_charles.check, 1000);
		},
		check: check,
		showingMenu: showingMenu,
		menuDisableCharles: menuDisableCharles,
		menuDirectConnection: menuDirectConnection,
		menuDisplayFirefoxProfilePath: menuDisplayFirefoxProfilePath,
		installCASSLCertificate: installCASSLCertificate
	};
}();

/* Start up monitor */
window.addEventListener("load", com_xk72_charles.init, false); 
